
function CreateBaseTrigger()

    local data = {}

    data["token"] = ""
    data["description"] = ""
    data["target_name"] = ""
    data["timer"] = 0
    data["icon"] = nil
    data["id"] = Turbine.Engine.GetGameTime()
    data["text"] = nil
    data["threshold"] = 3
    data["popup_multi"] = 2
    data["flashing"] = true
    data["loop"] = false
    data["reset"] = false
    data["unique"] = false
    data["sort_index"] = 0
    data["type"] = 0
    data["protected"] = false
	data["use_regex"] = false
	data["hide_text"] = false

    return data

end

function addtowindow_NewEffectSelf(w_data)

    local index = table.getn(w_data["list_effects_self"]) + 1

    w_data["list_effects_self"][index] = CreateBaseTrigger()
    w_data["list_effects_self"][index]["sort_index"] = w_data["next_index"]
    w_data["list_effects_self"][index]["type"] = EFFECTS_SELF
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_effects_self"][index]

end

function addtowindow_NewEffectGroup(w_data)

    local index = table.getn(w_data["list_effects_group"]) + 1

    w_data["list_effects_group"][index] = CreateBaseTrigger()
    w_data["list_effects_group"][index]["sort_index"] = w_data["next_index"]
    w_data["list_effects_group"][index]["type"] = EFFECTS_GROUP
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_effects_group"][index]

end

function addtowindow_NewEffectTarget(w_data)

    local index = table.getn(w_data["list_effects_target"]) + 1

    w_data["list_effects_target"][index] = CreateBaseTrigger()
    w_data["list_effects_target"][index]["sort_index"] = w_data["next_index"]
    w_data["list_effects_target"][index]["type"] = EFFECTS_TARGET
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_effects_target"][index]

end

function addtowindow_NewChat(w_data)

    local index = table.getn(w_data["list_chat"]) + 1

    w_data["list_chat"][index] = CreateBaseTrigger()
    w_data["list_chat"][index]["sort_index"] = w_data["next_index"]
    w_data["list_chat"][index]["type"] = CHAT
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_chat"][index]

end

function addtowindow_NewSkill(w_data)

    local index = table.getn(w_data["list_skill"]) + 1

    w_data["list_skill"][index] = CreateBaseTrigger()
    w_data["list_skill"][index]["sort_index"] = w_data["next_index"]
    w_data["list_skill"][index]["type"] = SKILL
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_skill"][index]

end

function addtowindow_NewTrigger_End(w_data)

    local index = table.getn(w_data["list_triggers_end"]) + 1

    w_data["list_triggers_end"][index] = CreateBaseTrigger()
    w_data["list_triggers_end"][index]["sort_index"] = w_data["next_index"]
    w_data["list_triggers_end"][index]["type"] = TRIGGER_END
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_triggers_end"][index]

end


function addtowindow_NewTrigger_Start(w_data)

    local index = table.getn(w_data["list_triggers_start"]) + 1

    w_data["list_triggers_start"][index] = CreateBaseTrigger()
    w_data["list_triggers_start"][index]["sort_index"] = w_data["next_index"]
    w_data["list_triggers_start"][index]["type"] = TRIGGER_START
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_triggers_start"][index]

end


function window_GetIndex(window)
    for i,v in ipairs(windowdata) do

        if v["load"] then

            if windowdata[i] == window.data then
                return i
            end
        end
	end
	Turbine.Shell.WriteLine(window.data["name"])
    return 0
end


function addtowindow_NewTrigger_Threshold(w_data)

    local index = table.getn(w_data["list_triggers_threshold"]) + 1

    w_data["list_triggers_threshold"][index] = CreateBaseTrigger()
    w_data["list_triggers_threshold"][index]["sort_index"] = w_data["next_index"]
    w_data["list_triggers_threshold"][index]["type"] = TRIGGER_THRESHOLD
    w_data["next_index"] = w_data["next_index"] + 1

    SaveSettings()
    return w_data["list_triggers_threshold"][index]

end

function DuplicateWindow(index)

	local index2 = AddNewWindow()

	windowdata[index2]["name"] = 						windowdata[index]["name"]
	windowdata[index2]["type"] = 						windowdata[index]["type"]
	windowdata[index2]["load"] =						windowdata[index]["load"] 
	windowdata[index2]["width"] = 						windowdata[index]["width"] 
	windowdata[index2]["height"] = 						windowdata[index]["height"]
	windowdata[index2]["left"] = 						windowdata[index]["left"] 
	windowdata[index2]["top"] = 						windowdata[index]["top"] 
	windowdata[index2]["frame"] = 						windowdata[index]["frame"] 
	windowdata[index2]["spacing"] = 					windowdata[index]["spacing"]
	windowdata[index2]["next_index"] =					windowdata[index]["next_index"]
	windowdata[index2]["frame_color"]["R"] =			windowdata[index]["frame_color"]["R"]
	windowdata[index2]["frame_color"]["G"] =			windowdata[index]["frame_color"]["G"]
	windowdata[index2]["frame_color"]["B"] =			windowdata[index]["frame_color"]["B"]
	windowdata[index2]["back_color"]["R"] =				windowdata[index]["back_color"]["R"]
	windowdata[index2]["back_color"]["G"] =				windowdata[index]["back_color"]["G"]
	windowdata[index2]["back_color"]["B"] =				windowdata[index]["back_color"]["B"]
	windowdata[index2]["bar_color"]["R"] = 				windowdata[index]["bar_color"]["R"]
	windowdata[index2]["bar_color"]["G"] = 				windowdata[index]["bar_color"]["G"]
	windowdata[index2]["bar_color"]["B"] = 				windowdata[index]["bar_color"]["B"]
	windowdata[index2]["font_color_1"]["R"] =				windowdata[index]["font_color_1"]["R"]
	windowdata[index2]["font_color_1"]["G"] =				windowdata[index]["font_color_1"]["G"]
	windowdata[index2]["font_color_1"]["B"] =				windowdata[index]["font_color_1"]["B"]
	windowdata[index2]["font_color_2"]["R"] = 				windowdata[index]["font_color_2"]["R"]
	windowdata[index2]["font_color_2"]["G"] = 				windowdata[index]["font_color_2"]["G"]
	windowdata[index2]["font_color_2"]["B"] = 				windowdata[index]["font_color_2"]["B"]
	windowdata[index2]["font"] =						windowdata[index]["font"]
	windowdata[index2]["opacity"] = 					windowdata[index]["opacity"] 
	windowdata[index2]["ascending"] = 					windowdata[index]["ascending"]
	windowdata[index2]["orientation_horizontal"] =		windowdata[index]["orientation_horizontal"]

	local coin = 10000
	for i,v in ipairs(windowdata[index]["list_effects_self"]) do
		local t = addtowindow_NewEffectSelf(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000
	end

	for i,v in ipairs(windowdata[index]["list_effects_group"]) do
		local t = addtowindow_NewEffectGroup(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	for i,v in ipairs(windowdata[index]["list_chat"]) do
		local t = addtowindow_NewChat(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	for i,v in ipairs(windowdata[index]["list_skill"]) do
		local t = addtowindow_NewSkill(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	for i,v in ipairs(windowdata[index]["list_effects_target"]) do
		local t = addtowindow_NewEffectTarget(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	for i,v in ipairs(windowdata[index]["list_triggers_end"]) do
		local t = addtowindow_NewTrigger_End(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	for i,v in ipairs(windowdata[index]["list_triggers_start"]) do
		local t = addtowindow_NewTrigger_Start(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	for i,v in ipairs(windowdata[index]["list_triggers_threshold"]) do
		local t = addtowindow_NewTrigger_Threshold(windowdata[index2])

		t["token"] = v["token"]
		t["description"] = v["description"]
		t["target_name"] = v["target_name"]
		t["timer"] = v["timer"]
		t["icon"] = v["icon"]
		t["text"] = v["text"]
		t["threshold"] = v["threshold"]
		t["popup_multi"] = v["popup_multi"]
		t["flashing"] = v["flashing"]
		t["loop"] = v["loop"]
		t["reset"] = v["reset"]
		t["unique"] = v["unique"]
		t["protected"] = v["protected"]
		t["use_regex"] = v["use_regex"]
		t["id"] = v["id"]-coin

		coin = coin+10000

	end

	SaveSettings()

end

function SortWindows()

	for i=1, table.getn(windowdata), 1 do 

		local index = i
		for j=i, table.getn(windowdata), 1 do 

			if SortStrings(windowdata[index]["name"],windowdata[j]["name"]) then
				index = j
			end

		end

		local temp = windowdata[i]
		windowdata[i] = windowdata[index]
		windowdata[index] = temp

	end

end


function AddNewWindow()

    local index = table.getn(windowdata)+1

    windowdata[index] = {}
    windowdata[index]["name"] = "New Window "..windowdata["next_id"]
    windowdata[index]["type"] = "Bar_ListBox"
    windowdata[index]["id"] = windowdata["next_id"]
    windowdata[index]["load"] = true
    windowdata[index]["group"] = nil
    windowdata[index]["width"] = 150
    windowdata[index]["height"] = 20
    windowdata[index]["left"] = 100
    windowdata[index]["top"] = 100
    windowdata[index]["frame"] = 1
    windowdata[index]["spacing"] = 2
    windowdata[index]["next_index"] = 1
    windowdata[index]["frame_color"] = {}
    windowdata[index]["frame_color"]["R"] = 0
    windowdata[index]["frame_color"]["G"] = 0
    windowdata[index]["frame_color"]["B"] = 0
    windowdata[index]["back_color"] = {}
    windowdata[index]["back_color"]["R"] = 1
    windowdata[index]["back_color"]["G"] = 1
    windowdata[index]["back_color"]["B"] = 1
    windowdata[index]["bar_color"] = {}
    windowdata[index]["bar_color"]["R"] = 0
    windowdata[index]["bar_color"]["G"] = 0
    windowdata[index]["bar_color"]["B"] = 0
	windowdata[index]["font_color_1"] = {}
    windowdata[index]["font_color_1"]["R"] = 1
    windowdata[index]["font_color_1"]["G"] = 1
    windowdata[index]["font_color_1"]["B"] = 1
	windowdata[index]["font_color_2"] = {}
    windowdata[index]["font_color_2"]["R"] = 1
    windowdata[index]["font_color_2"]["G"] = 1
    windowdata[index]["font_color_2"]["B"] = 1
    windowdata[index]["font"] = 23
    windowdata[index]["opacity"] = 0.5
    windowdata[index]["ascending"] = false
    windowdata[index]["orientation_horizontal"] = false
    windowdata[index]["list_effects_self"] = {}
    windowdata[index]["list_effects_group"] = {}
    windowdata[index]["list_chat"] = {}
    windowdata[index]["list_skill"] = {}
    windowdata[index]["list_effects_target"] = {}
    windowdata[index]["list_triggers_end"] = {}
    windowdata[index]["list_triggers_start"] = {}
    windowdata[index]["list_triggers_threshold"] = {}
    --windowdata[index]["all_self_debuffs"] = true
    --windowdata[index]["all_self_debuffs_data"] = CreateBaseTrigger()
    --windowdata[index]["all_self_debuffs_blacklist"] = {}
    --windowdata[index]["all_self_buffs"] = false

    windowdata["next_id"] = windowdata["next_id"] +1

    window_Create(index)

    SaveSettings()

    return index

end

function RemoveWindow(index)

    if windowdata[index] ~= nil then

        window_Close(index)

        local count = table.getn(windowdata)

        if count == 1 then

            windowdata[index] = nil


        elseif count > 1  then

            windowdata[index] = nil
            windowdata[index] = windowdata[count]
            windowdata[count] = nil

        else
            Turbine.Shell.WriteLine("Remove Window Error!")
        end

        SaveSettings()

    end
    
end

function SortStrings(a, b)--return a > b

	local len = math.min(string.len(a), string.len(b))

	for i=1, len, 1 do
		local a1 = string.sub(a, i, i)
		local b1 = string.sub(b, i, i)
		if a1 > b1 then
			return true
		elseif b1 > a1 then
			return false
		end
	end
	if string.len(a) == len then
		return false
	else
		return true
	end

end


function SortGroups()

	for i=1, table.getn(windowdata), 1 do 

		local index = i
		for j=i, table.getn(windowdata["window_groups"]), 1 do 

			if SortStrings(windowdata["window_groups"][index]["name"],windowdata["window_groups"][j]["name"]) then
				index = j
			end

		end

		local temp = windowdata["window_groups"][i]
		windowdata["window_groups"][i] = windowdata["window_groups"][index]
		windowdata["window_groups"][index] = temp

	end

end


function AddNewGroup(name)

    local index = table.getn(windowdata["window_groups"]) + 1

    windowdata["window_groups"][index] = {}
    windowdata["window_groups"][index]["load"] = true
    windowdata["window_groups"][index]["name"] = name
    windowdata["window_groups"][index]["collapsed"] = false
    windowdata["window_groups"][index]["id"] = windowdata["next_group_id"]

    windowdata["next_group_id"] = windowdata["next_group_id"] + 1

	SortGroups()

    SaveSettings()

    return index

end

function RemoveGroup(index)

	local count = table.getn(windowdata["window_groups"])
	local id = windowdata["window_groups"][index]["id"]

    if count == 1 then
        windowdata["window_groups"][index] = nil
    elseif count > 1 then
        windowdata["window_groups"][index] = nil
        windowdata["window_groups"][index] = windowdata["window_groups"][count]
        windowdata["window_groups"][count] = nil
    else
        return
    end
  
    for i=1, table.getn(windowdata), 1 do
        if windowdata[i]["group"] == id then
            windowdata[i]["group"] = nil
        end
    end

    SaveSettings()

end

function trigger_GetIndex(trigger, list)
    for i=1, table.getn(list), 1 do
        if trigger == list[i] then
            return i
        end
    end
end


function trigger_Remove(trigger, window)

    local list
    local type = trigger["type"]

    if type == EFFECTS_SELF then
        list = window["list_effects_self"]
    elseif type == EFFECTS_GROUP then
        list = window["list_effects_group"]
    elseif type == EFFECTS_TARGET then
        list = window["list_effects_target"]
    elseif type == CHAT then
        list = window["list_chat"]
    elseif type == SKILL then
        list = window["list_skill"]
    elseif type == TRIGGER_END then
        list = window["list_triggers_end"]
    elseif type == TRIGGER_START then
        list = window["list_triggers_start"]
    elseif type == TRIGGER_THRESHOLD then
        list = window["list_triggers_threshold"]
    end
    
    local count = table.getn(list)

    if count == 1 then 
        list[1] = nil
    elseif count == 0 then

    else
        local index = trigger_GetIndex(trigger, list)
        list[index] = list[count]
        list[count] = nil
    end

    SaveSettings()

end



function SetTarget_CollectEffects(value)
    collect_target_effects = value
end

function SetTarget_OnlyBuffs(value)
    effects_target_only_buffs = value
end

function SetEffects_Collect(value)
    collect_effects = value
end

function SetChat_Collect(value)
    collect_chat = value
end

function SetEffect_OnlyDebuffs(value)
    effects_only_debuffs = value
end

function SetChat_OnlySay(value)
    chat_only_say = value
end

