
GridWindow = class( Turbine.UI.Window )

function GridWindow:Constructor()
    Turbine.UI.Window.Constructor( self )

    self:Draw()
end

function GridWindow:Draw()

    local screen_width , screen_height = Turbine.UI.Display:GetSize()

    local parts = 100

    local left_space = screen_width / parts
    local top_space = screen_height / parts

    self:SetSize(screen_width, screen_height)
    self:SetPosition(0,0)
    self:SetMouseVisible(false)
   -- self:SetBackColor(Turbine.UI.Color.White)
    self:SetOpacity(0.4)

    self.vertical_lines = {}

    self.horizontal_lines = {}

    for i=1, parts-1, 1 do

        self.horizontal_lines[i] = self:GetLine()
        self.horizontal_lines[i]:SetPosition(0, (top_space * i) - 1)
        self.horizontal_lines[i]:SetSize(screen_width, 2)

        self.vertical_lines[i] = self:GetLine()
        self.vertical_lines[i]:SetPosition((left_space * i) - 1, 0)
        self.vertical_lines[i]:SetSize(2, screen_height)

    end

    local quater = parts/4
    self.horizontal_lines[quater]:SetHeight(6)
    self.horizontal_lines[quater]:SetTop(self.horizontal_lines[quater]:GetTop() - 2)

    self.horizontal_lines[2 * quater]:SetHeight(6)
    self.horizontal_lines[2 * quater]:SetTop(self.horizontal_lines[2 * quater]:GetTop() - 2)

    self.horizontal_lines[3 * quater]:SetHeight(6)
    self.horizontal_lines[3 * quater]:SetTop(self.horizontal_lines[3 * quater]:GetTop() - 2)

    self.vertical_lines[quater]:SetWidth(6)
    self.vertical_lines[quater]:SetLeft(self.vertical_lines[quater]:GetLeft() - 2)

    self.vertical_lines[2 * quater]:SetWidth(6)
    self.vertical_lines[2 * quater]:SetLeft(self.vertical_lines[2 * quater]:GetLeft() - 2)

    self.vertical_lines[3 * quater]:SetWidth(6)
    self.vertical_lines[3 * quater]:SetLeft(self.vertical_lines[3 * quater]:GetLeft() - 2)

    self:SetVisible(true)

end

function GridWindow:GetLine()

    local item = Turbine.UI.Control()
    item:SetParent(self)
    item:SetBackColor(Turbine.UI.Color.Black)    
    item:SetMouseVisible(false)

    return item
    
end