
MoveWindow = class( Turbine.UI.Window )

function MoveWindow:Constructor()
    Turbine.UI.Window.Constructor( self )

    self:ShowGridChanged()

    self:SetSize(200 + 10, 90 + 90)
    self:SetPosition(200, 400)
    self:SetMouseVisible(false)
    self:SetZOrder(99)

    self.back = UI.Settings.BaseWindow(170, 150,  0,  0, Turbine.UI.Color.White, Turbine.UI.Color.Black, "", self, 200, 30, 200, 30)
    self.back:ChangeVisiblility(true)
    self.back:SetZOrder(2)

    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetPosition(5, 25)
    self.foreground:SetSize(170 , 90 + 90 )
    self.foreground:SetVisible(true)
    self.foreground:SetZOrder(6) 

    self.pos_label = Turbine.UI.Label()
    self.pos_label:SetParent(self.foreground)
    self.pos_label:SetSize(50, 20)
    self.pos_label:SetPosition(5, 5)
    self.pos_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.pos_label:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.pos_label:SetText(Utils.L[locale]["position"])
    self.pos_label:SetForeColor(Turbine.UI.Color.White)

    self.left = Turbine.UI.Lotro.TextBox()
	self.left:SetParent(self.foreground)
	self.left:SetSize(45,20)
	self.left:SetPosition(55,5)
	self.left:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.left:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.left:SetText("")
    self.left.FocusLost = function()
        if self.left:IsEnabled() then
            move_selection:LeftChanged(tonumber(self.left:GetText()))
        end
    end
    self.left.KeyDown = function(sender, args) --162 == Enter
        if args.Action == 162  then 
            move_selection:LeftChanged(tonumber(self.left:GetText()))
            self.top:Focus()
        end
    end

    self.top = Turbine.UI.Lotro.TextBox()
	self.top:SetParent(self.foreground)
	self.top:SetSize(45,20)
	self.top:SetPosition(105,5)
	self.top:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.top:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.top:SetText("")
    self.top.FocusLost = function()
        if self.top:IsEnabled() then
            move_selection:TopChanged(tonumber(self.top:GetText()))
        end
    end
    self.top.KeyDown = function(sender, args) --162 == Enter
        if args.Action == 162  then 
            move_selection:TopChanged(tonumber(self.top:GetText()))
        end
    end

    self.left:SetEnabled(false)
    self.top:SetEnabled(false)

--
    self.size_label = Turbine.UI.Label()
    self.size_label:SetParent(self.foreground)
    self.size_label:SetSize(50, 20)
    self.size_label:SetPosition(5, 30)
    self.size_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.size_label:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.size_label:SetText(Utils.L[locale]["size"])
    self.size_label:SetForeColor(Turbine.UI.Color.White)

    self.width = Turbine.UI.Lotro.TextBox()
	self.width:SetParent(self.foreground)
	self.width:SetSize(45,20)
	self.width:SetPosition(55,30)
	self.width:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.width:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.width:SetText("")
    self.width.FocusLost = function()
        if self.width:IsEnabled() then
            move_selection:WidthChanged(tonumber(self.width:GetText()))
        end
    end
    self.width.KeyDown = function(sender, args) --162 == Enter
        if args.Action == 162  then 
            move_selection:WidthChanged(tonumber(self.width:GetText()))
            self.height:Focus()
        end
    end

    self.height = Turbine.UI.Lotro.TextBox()
	self.height:SetParent(self.foreground)
	self.height:SetSize(45,20)
	self.height:SetPosition(105,30)
	self.height:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.height:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.height:SetText("")
    self.height.FocusLost = function()
        if self.height:IsEnabled() then
            move_selection:HeightChanged(tonumber(self.height:GetText()))
        end
    end
    self.height.KeyDown = function(sender, args) --162 == Enter
        if args.Action == 162  then 
            move_selection:HeightChanged(tonumber(self.height:GetText()))
        end
    end

    self.width:SetEnabled(false)
    self.height:SetEnabled(false)

    self.show_groups =  Turbine.UI.Lotro.CheckBox()
	self.show_groups:SetParent(self.foreground)
	self.show_groups:SetMouseVisible(false)
	self.show_groups:SetSize(200, 26)
	self.show_groups:SetPosition(5,60)
	self.show_groups:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.show_groups:SetText(Utils.L[locale]["show_group"])
    self.show_groups:SetChecked(show_groups)
    self.show_groups.CheckedChanged = function()

        show_groups_changed(self.show_groups:IsChecked())

    end

    self.show_grid =  Turbine.UI.Lotro.CheckBox()
	self.show_grid:SetParent(self.foreground)
	self.show_grid:SetMouseVisible(false)
	self.show_grid:SetSize(200, 26)
	self.show_grid:SetPosition(5,90)
	self.show_grid:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.show_grid:SetText(Utils.L[locale]["show_grid"])
    self.show_grid:SetChecked(show_grid)
    self.show_grid.CheckedChanged = function()

        show_grid_changed(not(show_grid))

        self:ShowGridChanged()

    end

    self.done_button = Turbine.UI.Lotro.Button()
    self.done_button:SetParent(self.foreground)
    self.done_button:SetPosition(5,120)
    self.done_button:SetSize(100,20)
    self.done_button:SetText(Utils.L[locale]["button"]["done"])
    self.done_button:SetVisible(true)

    self.done_button.Click = function(sender, args)
        window_MovingChanged(false)
        c_icon.item_move:SetChecked(moving)
    end

    self:SetVisible(true)

end

function MoveWindow:ShowGridChanged()

    if show_grid then

        if self.grid == nil then
            self.grid = GridWindow()
        end

    else

        if self.grid ~= nil then
            self.grid:Close()
            self.grid = nil
        end

    end

end

function MoveWindow:Resize()

end

function MoveWindow:MoveSelectionChanged()

    self.left:SetEnabled(true)
    self.top:SetEnabled(true)
    self.width:SetEnabled(true)
    self.height:SetEnabled(true)

    self.back.label:SetText(move_selection.data["name"])
    self.left:SetText(move_selection:GetLeft())
    self.top:SetText(move_selection:GetTop())
    self.width:SetText(move_selection.data["width"])
    self.height:SetText(move_selection.data["height"])

end

function MoveWindow:MoveSelectionMoved()

    self.left:SetText(move_selection:GetLeft())
    self.top:SetText(move_selection:GetTop())

end

function MoveWindow:Closing()

    self.back:Close()
    self.foreground:Close()
    if self.grid ~= nil then
        self.grid:Close()
    end

end