
---------------------------------------------------------------------
--== window-functions ===--
---------------------------------------------------------------------

function group_Close()

end

function move_selection_Changed(item)

    if move_selection ~= nil then
        move_selection:RemoveMoveFocus()
    end

	move_selection = item
	if move_window ~= nil then
		move_window:MoveSelectionChanged()
	end

    if move_selection ~= nil then
        move_selection:AddMoveFocus()
    end
end

function move_group(x_diff, y_diff)

	if move_selection ~= nil then

		for i,windata in ipairs(windowdata) do 

			if (windata["load"] == true) and windata["group"] == move_selection.data["id"] then
	
				windows[i]:GroupMove(x_diff, y_diff)
	
			end
	
		end

	end

end

function move_selection_Moved()
	if move_window ~= nil then
		move_window:MoveSelectionMoved()
	end
	if move_selection.data["group"] ~= nil then
		for i=1, table.getn(windowdata["window_groups"]), 1 do
			if windowdata["window_groups"][i]["load"] then
				if windowdata["window_groups"][i]["id"] == move_selection.data["group"] then
                    if  groups[i] ~= nil then
					    groups[i]:ChildMoved()
                    end
				end
			end
		end
	end
end


function show_groups_changed(bool)

	show_groups = bool

	for i,data in ipairs(windowdata["window_groups"]) do 
		if data["load"] then
            if groups[i] ~= nil then
			    groups[i]:Show_Changed()
            end
		end
	end

end

function show_grid_changed(bool)

	show_grid = bool

end

function window_MovingChanged(bool)

    if bool == nil then
        moving = not(moving)
    else
        moving = bool
    end

    for i,windata in ipairs(windowdata) do 

        if (windata["load"]) then

            windows[i]:MovingChanged(moving)

        end

	end
	
	if moving then

		move_selection = nil
        if move_window == nil then
            move_window = UI.Settings.MoveWindow()
        end

		for i,data in ipairs(windowdata["window_groups"]) do 
			if data["load"] then
				groups[i] = UI.Windows.Group(data)
			end
		end

	else

		move_window:Close()
        move_window = nil

		for i,data in ipairs(windowdata["window_groups"]) do 
			if data["load"] then
                if groups[i] ~= nil then
                    groups[i]:Close()
                    groups[i] = nil
                end
			end
		end

	end
	OptionsReload()

end


function window_GroupMoving(group_index)

    if moving == false then

        local id = windowdata["window_groups"][group_index]["id"]

        move_selection = nil
        if move_window == nil then
            move_window = UI.Settings.MoveWindow()
        end

        if windowdata["window_groups"][group_index]["load"] == true then
            groups[group_index] = UI.Windows.Group(windowdata["window_groups"][group_index])
        end

        for i,windata in ipairs(windowdata) do 

            if (windata["load"]) and windata["group"] == id then

                windows[i]:MovingChanged(true)

            end

        end

	end

end


function window_WindowMoving(window_index)

    if moving == false then

        move_selection = nil
        if move_window == nil then
            move_window = UI.Settings.MoveWindow()
        end

        if (windowdata[window_index]["load"]) then

            windows[window_index]:MovingChanged(true)

        end

    end

end


function window_Create(index)

    if(windowdata[index]["type"] == "Bar_ListBox") then
        windows[index] = UI.Windows.Bar_ListBox(windowdata[index])

    elseif( windowdata[index]["type"] == "Bar_Window") then
        windows[index] = UI.Windows.Bar_Window(windowdata[index])

    elseif( windowdata[index]["type"] == "Icon_ListBox") then
        windows[index] = UI.Windows.Icon_ListBox(windowdata[index])

    elseif( windowdata[index]["type"] == "Icon_Window") then
        windows[index] = UI.Windows.Icon_Window(windowdata[index])

    else

        Turbine.Shell.WriteLine("SaveFile corrupted!")

    end

    SaveSettings()

end

function window_Close(index)

    if windowdata[index]["load"] then
		if windows[index] ~= nil then
        	windows[index]:Close()
		end
    end

end

function window_CreateAll()

    for i=1, table.getn(windowdata), 1 do

        if(windowdata[i]["load"] == true) then
    
           window_Create(i)
    
        end
    
    end
    SaveSettings()

end

function window_DataChanged()

    for i=1, table.getn(windowdata), 1 do

        if(windowdata[i]["load"] == true) then
            windows[i]:Reload()
        end

    end

end

---------------------------------------------------------------------
--== settings-functions ===--
---------------------------------------------------------------------

function settings_Open()

    if settings_window == nil then
        settings_window = UI.Settings.Options.Window(windowdata)
    else
        settings_window:Close()
		settings_window = nil
    end
	OptionsReload()

end

function settings_Close( reload )

	if settings_window ~= nil then
		settings_window:Close()
		settings_window = nil
	end

    if reload then

        ReloadPlugin("Gibberish reload reason: \"options saved\"")

	else

		OptionsReload()

    end

end

function TrackGroupChanged()
    if windowdata["track_effects_group"] then
        Trigger.AddGroupEffectEvents()
    end
    c_icon:TrackGroupChanged()
end

function TrackTargetChanged()
    if windowdata["track_effects_target"] then
        Trigger.AddEventTargetEffects()
    end
    c_icon:TrackTargetChanged()
	if collectors_window ~= nil then
		collectors_window:TrackTargetChanged()
	end
end

---------------------------------------------------------------------
--== collection-functions ===--
---------------------------------------------------------------------

function check_activ_Effects()

    if collect_effects then
        Trigger.check_activ_Effects_forCollection_Self()


        if windowdata["track_effects_group"] then
            Trigger.check_activ_Effects_forCollection_Group()
        end
    end

    if collect_target_effects then
        if windowdata["track_effects_target"] then
            Trigger.check_activ_Effects_forCollection_Target()
        end
    end

end

function collection_Open()

    if collectors_window == nil then
        collectors_window = UI.Settings.Collection.Window()
    else
        collectors_window:Close()
    end
	OptionsReload()

end

function collection_Close()

    collectors_window = nil
	OptionsReload()

end

function  EffectCollectionChanged(index)
    if collectors_window ~= nil then
        collectors_window:EffectCollectionChanged(index)
    end

    if settings_window ~= nil then
        settings_window:EffectCollectionChanged(index)
    end
end

function  ChatCollectionChanged(index)
    if collectors_window ~= nil then
        collectors_window:ChatCollectionChanged(index)
    end

    if settings_window ~= nil then
        settings_window:ChatCollectionChanged(index)
    end
end