
---------------------------------------------------------------------
--== chat comand ===--
---------------------------------------------------------------------

command = Turbine.ShellCommand()

function command:Execute( _, str )
    if str == nil or string.len( str ) == 0 then
        Turbine.Shell.WriteLine( "Missing Argument (reset | reload).")
        return
    end

    local list  = { }
    local index = 1

    for word in str:gmatch( "%w+" ) do
        list[ index ] = word
        index = index + 1
    end

    local cmd = string.lower( list[ 1 ] )

    if cmd == "options" then

        settings_Open()

    elseif cmd == "print" then

        local string = "Gibberish Print:\n"

        for k,v in ipairs(windowdata) do
            if v["load"] then
                string = string.."["..windowdata[k]["name"].."] <load>\n"
                for i,t in ipairs(windows[k].controls) do
                    string = string.." > ["..t.data["text"].."] "..t.data["token"].."\n"
                end
            else
                string = string.."["..windowdata[k]["name"].."] <not load>\n"
            end
        end

        Turbine.Shell.WriteLine(string)

    elseif cmd == "reload" then

        ReloadPlugin(nil)

    elseif cmd == "move" then

        moving = not(moving)
        MovingChanged()
       
    elseif cmd == "reset" then

        if table.getn(list) == 2 then

            for i,w_data in ipairs(windowdata) do
                if string.lower(w_data["name"]) == string.lower(list[2]) then

                    windows[i]:ResetAll()

                    return
                end
            end

        else
        
            for i,w_data in ipairs(windowdata) do
                if w_data["load"] then
                    windows[i]:ResetAll()
                end
            end

        end

    else
        Turbine.Shell.WriteLine( "Invalid command: " .. cmd )
    end

end

Turbine.Shell.AddCommand( "gibberish", command )
